<?php
/*********************************************************************************
 * The contents of this file are subject to the TimeTrex Public License Version
 * 1.1.0 ("License"); You may not use this file except in compliance with the
 * License. You may obtain a copy of the License at http://www.TimeTrex.com/TPL
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied.  See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * All copies of the Covered Code must include on each user interface screen:
 *    (i) the "Powered by TimeTrex" logo and
 *    (ii) the TimeTrex copyright notice
 * in the same form as they appear in the distribution.  See full license for
 * requirements.
 *
 * The Original Code is: TimeTrex Open Source
 * The Initial Developer of the Original Code is TimeTrex Payroll Services
 * Portions created by TimeTrex are Copyright (C) 2004-2007 TimeTrex Payroll Services;
 * All Rights Reserved.
 *
 ********************************************************************************/
/*
 * $Revision: 273 $
 * $Id: OtherFieldFactory.class.php 273 2006-10-20 18:27:30Z ipso $
 * $Date: 2006-10-20 11:27:30 -0700 (Fri, 20 Oct 2006) $
 */
class OtherFieldFactory extends Factory {
	protected $table = 'other_field';
	protected $pk_sequence_name = 'other_field_id_seq'; //PK Sequence name

	protected $company_obj = NULL;

	protected $type_options = array(
											10  => 'Employee',
											15  => 'Punch',
											20 	=> 'Job',
											30	=> 'Task',
											50  => 'Client',
											55  => 'Client Contact',
											//57  => 'Client Payment',
											60  => 'Product',
											70  => 'Invoice',
											80  => 'Document',
									);

	protected $type_validator_options_msg = 'Incorrect Type';
	protected $type_validator_label = 'type';

	protected $company_validator_msg = 'Company is invalid';
	protected $company_validator_label = 'company';

	protected $otherid1_validator_islength_msg = 'Other ID1 is invalid';
	protected $otherid1_validator_label = 'other_id1';

	protected $otherid2_validator_islength_msg = 'Other ID2 is invalid';
	protected $otherid2_validator_label = 'other_id2';

	protected $otherid3_validator_islength_msg = 'Other ID3 is invalid';
	protected $otherid3_validator_label = 'other_id3';

	protected $otherid4_validator_islength_msg = 'Other ID4 is invalid';
	protected $otherid4_validator_label = 'other_id4';

	protected $otherid5_validator_islength_msg = 'Other ID5 is invalid';
	protected $otherid5_validator_label = 'other_id5';

	protected $otherid6_validator_islength_msg = 'Other ID6 is invalid';
	protected $otherid6_validator_label = 'other_id6';

	protected $otherid7_validator_islength_msg = 'Other ID7 is invalid';
	protected $otherid7_validator_label = 'other_id7';

	protected $otherid8_validator_islength_msg = 'Other ID8 is invalid';
	protected $otherid8_validator_label = 'other_id8';

	protected $otherid9_validator_islength_msg = 'Other ID9 is invalid';
	protected $otherid9_validator_label = 'other_id9';

	protected $otherid10_validator_islength_msg = 'Other ID10 is invalid';
	protected $otherid10_validator_label = 'other_id10';

	function getCompanyObject() {
		if ( is_object($this->company_obj) ) {
			return $this->company_obj;
		} else {
			$clf = new CompanyListFactory();
			$this->company_obj = $clf->getById( $this->getCompany() )->getCurrent();

			return $this->company_obj;
		}
	}

	function getCompany() {
		if ( isset($this->data['company_id']) ) {
			return $this->data['company_id'];
		}

		return FALSE;
	}
	function setCompany($id) {
		$id = trim($id);

		Debug::Text('Company ID: '. $id, __FILE__, __LINE__, __METHOD__,10);
		$clf = new CompanyListFactory();

		if ( $this->Validator->isResultSetWithRows(	$this->company_validator_label,
													$clf->getByID($id),
													$this->company_validator_msg
													) ) {

			$this->data['company_id'] = $id;

			return TRUE;
		}

		return FALSE;
	}

	function getType() {
		return $this->data['type_id'];
	}
	function setType($type) {
		$type = trim($type);

		//$jif = new JobItemFactory();
		$key = Option::getByValue($type, $this->getOptions('type') );
		if ($key !== FALSE) {
			$type = $key;
		}

		if ( $this->Validator->inArrayKey(	$this->type_validator_label,
											$type,
											$this->type_validator_options_msg,
											$this->getOptions('type') ) ) {

			$this->data['type_id'] = $type;

			return FALSE;
		}

		return FALSE;
	}

	function getOtherID1() {
		return $this->data['other_id1'];
	}
	function setOtherID1($value) {
		$value = trim($value);

		if (	$value == ''
				OR
				$this->Validator->isLength(	$this->otherid1_validator_label,
											$value,
											$this->otherid1_validator_islength_msg,
											1,255) ) {

			$this->data['other_id1'] = $value;

			return TRUE;
		}

		return FALSE;
	}

	function getOtherID2() {
		return $this->data['other_id2'];
	}
	function setOtherID2($value) {
		$value = trim($value);

		if (	$value == ''
				OR
				$this->Validator->isLength(	$this->otherid2_validator_label,
											$value,
											$this->otherid2_validator_islength_msg,
											1,255) ) {

			$this->data['other_id2'] = $value;

			return TRUE;
		}

		return FALSE;
	}

	function getOtherID3() {
		return $this->data['other_id3'];
	}
	function setOtherID3($value) {
		$value = trim($value);

		if (	$value == ''
				OR
				$this->Validator->isLength(	$this->otherid3_validator_label,
											$value,
											$this->otherid3_validator_islength_msg,
											1,255) ) {

			$this->data['other_id3'] = $value;

			return TRUE;
		}

		return FALSE;
	}

	function getOtherID4() {
		return $this->data['other_id4'];
	}
	function setOtherID4($value) {
		$value = trim($value);

		if (	$value == ''
				OR
				$this->Validator->isLength(	$this->otherid4_validator_label,
											$value,
											$this->otherid4_validator_islength_msg,
											1,255) ) {

			$this->data['other_id4'] = $value;

			return TRUE;
		}

		return FALSE;
	}

	function getOtherID5() {
		return $this->data['other_id5'];
	}
	function setOtherID5($value) {
		$value = trim($value);

		if (	$value == ''
				OR
				$this->Validator->isLength(	$this->otherid5_validator_label,
											$value,
											$this->otherid5_validator_islength_msg,
											1,255) ) {

			$this->data['other_id5'] = $value;

			return TRUE;
		}

		return FALSE;
	}

	function getOtherID6() {
		return $this->data['other_id6'];
	}
	function setOtherID6($value) {
		$value = trim($value);

		if (	$value == ''
				OR
				$this->Validator->isLength(	$this->otherid6_validator_label,
											$value,
											$this->otherid6_validator_islength_msg,
											1,255) ) {

			$this->data['other_id6'] = $value;

			return TRUE;
		}

		return FALSE;
	}

	function getOtherID7() {
		return $this->data['other_id7'];
	}
	function setOtherID7($value) {
		$value = trim($value);

		if (	$value == ''
				OR
				$this->Validator->isLength(	$this->otherid7_validator_label,
											$value,
											$this->otherid7_validator_islength_msg,
											1,255) ) {

			$this->data['other_id7'] = $value;

			return TRUE;
		}

		return FALSE;
	}

	function getOtherID8() {
		return $this->data['other_id8'];
	}
	function setOtherID8($value) {
		$value = trim($value);

		if (	$value == ''
				OR
				$this->Validator->isLength(	$this->otherid8_validator_label,
											$value,
											$this->otherid8_validator_islength_msg,
											1,255) ) {

			$this->data['other_id8'] = $value;

			return TRUE;
		}

		return FALSE;
	}

	function getOtherID9() {
		return $this->data['other_id9'];
	}
	function setOtherID9($value) {
		$value = trim($value);

		if (	$value == ''
				OR
				$this->Validator->isLength(	$this->otherid9_validator_label,
											$value,
											$this->otherid9_validator_islength_msg,
											1,255) ) {

			$this->data['other_id9'] = $value;

			return TRUE;
		}

		return FALSE;
	}

	function getOtherID10() {
		return $this->data['other_id10'];
	}
	function setOtherID10($value) {
		$value = trim($value);

		if (	$value == ''
				OR
				$this->Validator->isLength(	$this->otherid10_validator_label,
											$value,
											$this->otherid10_validator_islength_msg,
											1,255) ) {

			$this->data['other_id10'] = $value;

			return TRUE;
		}

		return FALSE;
	}

	function addLog( $log_action ) {
		return TTLog::addEntry( $this->getId(), $log_action, 'Other Fields', NULL, $this->getTable() );
	}
}
?>
