<?php
/**
 * Smarty plugin
 * @package Smarty
 * @subpackage plugins
 */

function smarty_function_select_size($params, &$smarty)
{
    global $current_user_prefs;

    //Ignore this for Mozilla browsers?

    $array = $params['array'];
    $min = $params['min'];
    $max = $params['max'];
    //Debug::text('Min: '. $min .' Max: '. $max, __FILE__, __LINE__, __METHOD__, 10);

    $total = count($array);

    if ( $min == '' AND is_object($current_user_prefs) ) {
        if ( $current_user_prefs->getItemsPerPage() > 50 ) {
            $divisor = 3;
        } else {
            $divisor = 2;
        }
        $min = $current_user_prefs->getItemsPerPage() / $divisor;
    } elseif ( $min == '' ) {
        $min = 5;
    }
    //Debug::text('aMin: '. $min, __FILE__, __LINE__, __METHOD__, 10);

    if ( $max == '' AND is_object($current_user_prefs) ) {
        $max = $current_user_prefs->getItemsPerPage() / $divisor;
    } elseif ( $max == '' ) {
        $max = 30;
    }
    //Debug::text('aMax: '. $max, __FILE__, __LINE__, __METHOD__, 10);

    if ( $total <= $min ) {
        //return $total;
        $size = $total;
        //Debug::text('aSize: '. $size, __FILE__, __LINE__, __METHOD__, 10);
    } else {
        if ( $total > 50 ) {
            $total_divsor = 3;
        } else {
            $total_divsor = 2;
        }
        if ( isset($total_divsor) ) {
            $size = $total / $total_divsor;
        }
    }
    //Debug::text('bSize: '. $size .' Max: '. $max, __FILE__, __LINE__, __METHOD__, 10);

    if ( $size > $max ) {
        //Debug::text('Using Max...', __FILE__, __LINE__, __METHOD__, 10);
        $retval = $max;
    } elseif ( $size <= $min ) {
        //Debug::text('Using Min...', __FILE__, __LINE__, __METHOD__, 10);
        $retval = $min;
    } else {
        //Debug::text('Using Size...', __FILE__, __LINE__, __METHOD__, 10);
        $retval = $size;
    }

    if ( $retval >= $total ) {
        //Debug::text('Using Total...', __FILE__, __LINE__, __METHOD__, 10);
        $retval = $total;
    }

    //Debug::text('Retval: '. $retval, __FILE__, __LINE__, __METHOD__, 10);

    return ceil($retval);
}

/* vim: set expandtab: */

?>
