<?php
/*********************************************************************************
 * The contents of this file are subject to the TimeTrex Public License Version
 * 1.1.0 ("License"); You may not use this file except in compliance with the
 * License. You may obtain a copy of the License at http://www.TimeTrex.com/TPL
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied.  See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * All copies of the Covered Code must include on each user interface screen:
 *    (i) the "Powered by TimeTrex" logo and
 *    (ii) the TimeTrex copyright notice
 * in the same form as they appear in the distribution.  See full license for
 * requirements.
 *
 * The Original Code is: TimeTrex Open Source
 * The Initial Developer of the Original Code is TimeTrex Payroll Services
 * Portions created by TimeTrex are Copyright (C) 2004-2007 TimeTrex Payroll Services;
 * All Rights Reserved.
 *
 ********************************************************************************/
/*
 * $Revision: 417 $
 * $Id: index.php 417 2006-12-06 22:58:53Z ipso $
 * $Date: 2006-12-06 14:58:53 -0800 (Wed, 06 Dec 2006) $
 */
require_once('../includes/global.inc.php');
require_once(Environment::getBasePath() .'includes/Interface.inc.php');

$title = 'Home';
$smarty->assign('title', $title);
BreadCrumb::setCrumb($title);

/*
 * Get FORM variables
 */
extract	(FormVariables::GetVariables(
										array	(
												'action',
												'id',
												'pref_data'
												) ) );

//Find last login name.
$llf = new LogListFactory();
$log_obj = $llf->getLastEntryByUserIdAndActionAndTable( $current_user->getId(), 'Login', 'authorization')->getCurrent();
$last_login_date = $log_obj->getDate();
Debug::text('Last Logged in Date: '. TTDate::getDate('DATE+TIME', $last_login_date) , __FILE__, __LINE__, __METHOD__,9);

//Find out which is greater, last login name, or 24hrs.
if ( $last_login_date > ( TTDate::getTime() - 86400 ) ) {
	$filter_date = ( TTDate::getTime() - 86400 );
} else {
	$filter_date = $last_login_date;
}
Debug::text('Filter Date: '. TTDate::getDate('DATE+TIME', $filter_date) , __FILE__, __LINE__, __METHOD__,9);

//Grab total number of exceptions for each severity level
$exceptions = array();

$elf = new ExceptionListFactory();
$elf->getFlaggedExceptionsByUserIdAndPayPeriodStatus( $current_user->getId(), 10 );
if ( $elf->getRecordCount() > 0 ) {
	foreach($elf as $e_obj) {
		if ( isset($exceptions[$e_obj->getColumn('severity_id')]) ) {
			$exceptions[$e_obj->getColumn('severity_id')]++;
		} else {
			$exceptions[$e_obj->getColumn('severity_id')] = 1;
		}
	}
}
unset($elf, $e_obj);
$smarty->assign_by_ref('exceptions', $exceptions);


//Grab list of recent requests
$rlf = new RequestListFactory();
$rlf->getByUserIDAndCompanyId( $current_user->getId(), $current_company->getId(), 5, 1 );
if ($rlf->getRecordCount() > 0 ) {
	$status_options = $rlf->getOptions('status');
	$type_options = $rlf->getOptions('type');

	foreach ($rlf as $r_obj) {
		$requests[] = array(
							'id' => $r_obj->getId(),
							'user_date_id' => $r_obj->getUserDateID(),
							'date_stamp' => TTDate::strtotime($r_obj->getColumn('date_stamp')),
							'status_id' => $r_obj->getStatus(),
							'status' => Misc::TruncateString( $status_options[$r_obj->getStatus()], 15 ),
							'type_id' => $r_obj->getType(),
							'type' => $type_options[$r_obj->getType()],
							'created_date' => $r_obj->getCreatedDate(),
							'deleted' => $r_obj->getDeleted()
						);
	}
}
$smarty->assign_by_ref('requests', $requests);

//Grab list of unread messages
$mlf = new MessageListFactory();
$mlf->getByUserIdAndFolder( $current_user->getId(), 10, 5, 1);
if ( $mlf->getRecordCount() > 0 ) {
	$object_name_options = $mlf->getOptions('object_name');

	$require_ack = FALSE;
	foreach ($mlf as $message) {
		//Get user info
		$ulf = new UserListFactory();

		if ( $message->isAck() == FALSE ) {
			$require_ack = TRUE;
		}

		if ( $message->getRequireAck() == TRUE ) {
			$show_ack_column = TRUE;
		}

		$messages[] = array(
							'id' => $message->getId(),
							'parent_id' => $message->getParent(),
							'object_type_id' => $message->getObjectType(),
							'object_type' => $object_name_options[$message->getObjectType()],
							'object_id' => $message->getObject(),
							'priority' => $message->getPriority(),
							'status_id' => $message->getStatus(),
							'require_ack' => $message->getRequireAck(),
							'ack_date' => $message->getAckDate(),
							'subject' => Misc::TruncateString( $message->getSubject(), 20 ),
							'body' => $message->getBody(),
							'created_date' => $message->getCreatedDate(),
							'created_by' => $message->getCreatedBy(),
							'created_by_full_name' => $ulf->getById( $message->getCreatedBy() )->getIterator()->current()->getFullName(),
							'updated_date' => $message->getUpdatedDate(),
							'updated_by' => $message->getUpdatedBy(),
							'deleted_date' => $message->getDeletedDate(),
							'deleted_by' => $message->getDeletedBy()
						);

	}
}
$smarty->assign_by_ref('messages', $messages);

//$smarty->assign_by_ref('shift_amendments', $shift_amendments);
//$smarty->assign_by_ref('schedule_amendments', $schedule_amendments);

$smarty->display('index.tpl');
?>